using System;
using Games.FrogLib;
using System.Text;
// Select a project node in Solution Explorer, 
// and then, on the Project TestFrogLib, click Properties. When the Project Designer appears, click the Application tab.
// click the Application tab.
// Startup object: You also have to define a public 
// static void Main() method in a class in the project. 
// This class will appear in the Startup object list as 4 classes: 
// TestFrogLib.TestFrog0
// TestFrogLib.TestFrog1
// TestFrogLib.TestFrog2
// TestFrogLib.TestFrog3
// You can then select the class as the startup object. 

namespace TestFrogLib
{
    class TestGrog3
    {
        static void Main(string[] args)
        {
            int size = 10;
            int brownFrogs = 2;
            FrogsBase[] frogs = new FrogsBase[size];
            int i;
            for (i = 0; i < brownFrogs; i++)
                frogs[i] = new BrownFrog(i, i.ToString());
            for (i = brownFrogs + 1; i < frogs.Length; i++)
                frogs[i] = new GreenFrog(i, i.ToString());
            Console.ReadKey(true);
            FrogsSwap(frogs, brownFrogs);
        }
        static void FrogsSwap(FrogsBase[] frogs, int mid)
        {
            if (mid == 0)
            {
                if (frogs[1] is GreenFrog)
                {
                    frogs[1].Move();
                    frogs[0] = frogs[1];
                    frogs[1] = null;
                    FrogsSwap(frogs, 1);
                }
                else
                    if (frogs[2] is GreenFrog)
                    {
                        frogs[2].Jump();
                        frogs[0] = frogs[2];
                        frogs[2] = null;
                        FrogsSwap(frogs, 2);
                    }
                return;
            }
            if (mid == frogs.Length - 1)
            {
                if (frogs[mid - 1] is BrownFrog)
                {
                    frogs[mid - 1].Move();
                    frogs[mid] = frogs[mid - 1];
                    frogs[mid - 1] = null;
                    FrogsSwap(frogs, mid - 1);
                }
                else
                    if (frogs[mid - 2] is BrownFrog)
                    {
                        frogs[mid - 2].Jump();
                        frogs[mid] = frogs[mid - 2];
                        frogs[mid - 2] = null;
                        FrogsSwap(frogs, mid - 2);
                    }
                return;
            }
            if (frogs[mid - 1] is GreenFrog && frogs[mid + 1] is BrownFrog)
            {
                if (mid + 2 < frogs.Length && frogs[mid + 2] is GreenFrog)
                {
                    frogs[mid + 2].Jump();
                    frogs[mid] = frogs[mid + 2];
                    frogs[mid + 2] = null;
                    FrogsSwap(frogs, mid + 2);
                    return;
                }
                if (mid - 2 >= 0 && frogs[mid - 2] is BrownFrog)
                {
                    frogs[mid - 2].Jump();
                    frogs[mid] = frogs[mid - 2];
                    frogs[mid - 2] = null;
                    FrogsSwap(frogs, mid - 2);
                }
                return;
            }

            if (frogs[mid - 1] is BrownFrog && frogs[mid + 1] is GreenFrog)
            {
                if (mid + 1 == frogs.Length - 1 || (mid + 2 < frogs.Length && frogs[mid + 2] is GreenFrog))
                {
                    //  Move Green Frog
                    frogs[mid + 1].Move();
                    frogs[mid] = frogs[mid + 1];
                    frogs[mid + 1] = null;
                    FrogsSwap(frogs, mid + 1);
                    return;
                }
                if (mid - 1 == 0 || (mid - 2 >= 0 && frogs[mid - 2] is BrownFrog))
                {
                    //  Move Brown Frog
                    frogs[mid - 1].Move();
                    frogs[mid] = frogs[mid - 1];
                    frogs[mid - 1] = null;
                    FrogsSwap(frogs, mid - 1);
                    return;
                }
                return;
            }
            if (frogs[mid - 1] is GreenFrog)
            {
                if ((mid - 2 >= 0 && frogs[mid - 2] is BrownFrog))
                {
                    frogs[mid - 2].Jump();
                    frogs[mid] = frogs[mid - 2];
                    frogs[mid - 2] = null;
                    FrogsSwap(frogs, mid -2);
                    return;
                }
                frogs[mid + 1].Move();
                frogs[mid] = frogs[mid + 1];
                frogs[mid + 1] = null;
                FrogsSwap(frogs, mid + 1);
                return;
            }
            if ((mid + 2 < frogs.Length && frogs[mid + 2] is GreenFrog))
            {
                
                    frogs[mid + 2].Jump();
                    frogs[mid] = frogs[mid + 2];
                    frogs[mid + 2] = null;
                    FrogsSwap(frogs, mid + 2);
                    return;
            }
            frogs[mid - 1].Move();
            frogs[mid] = frogs[mid -1];
            frogs[mid - 1] = null;
            FrogsSwap(frogs, mid - 1);
                    
        }
    }
}
